#include <string>
#include <vector>
#include <stack>
using namespace std;

#define PI 3.1415926535f

struct TurtleState
{
  float x, y;
  float alpha;
};

struct Production
{
  string predecessor;
  string contextl;
  string contextr;
  string rule;
  string successor;
};

class clsApplication
{
private:
  TurtleState mTurtle;
  stack<TurtleState> mTurtleStack;
  unsigned int mN, mD;
  float mDelta;
  string mAxiom;
  vector<Production> mProductions;
  string mProduct;
public:
  clsApplication();
  void openAndParseFile(char* pFile);
  unsigned int changeN(int pChange);
  void produce();
  void render(bool pDraw=true, bool pInfo=false); //pDraw==false -> just adjusts viewport boundaries

};