#include <windows.h>

#include <GL/gl.h>
#pragma comment (lib,"opengl32.lib")

#include "clsApplication.h"

HDC hDC=NULL;
HGLRC hRC=NULL;
HWND hWnd=NULL;
HINSTANCE hInstance;

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

void KillWindow()
{
	if (hRC)	{
		wglMakeCurrent(NULL,NULL);
    wglDeleteContext(hRC);
	}
	ReleaseDC(hWnd,hDC);
	DestroyWindow(hWnd);
	UnregisterClass(TEXT("pL-Pictures"),hInstance);
}
void InitWindow(int width, int height)
{
	GLuint PixelFormat;
	WNDCLASS wc;
	DWORD dwExStyle;
	DWORD dwStyle;
	RECT WindowRect;

	WindowRect.left=(long)0;
	WindowRect.right=(long)width;
	WindowRect.top=(long)0;
	WindowRect.bottom=(long)height;

	hInstance = GetModuleHandle(NULL);
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc = (WNDPROC) WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = NULL;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = TEXT("pL-Pictures");

	RegisterClass(&wc);
	
	dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
	dwStyle=(WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU);
	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);

	hWnd=CreateWindowEx(	dwExStyle,
							TEXT("pL-Pictures"),
								TEXT("pL-Pictures"),
								dwStyle |	
								WS_CLIPSIBLINGS |
								WS_CLIPCHILDREN,
								0, 0,
								WindowRect.right-WindowRect.left,
								WindowRect.bottom-WindowRect.top,
								NULL,
								NULL,
								hInstance,
								NULL);

	static	PIXELFORMATDESCRIPTOR pfd=
	{
		sizeof(PIXELFORMATDESCRIPTOR),
		1,
		PFD_DRAW_TO_WINDOW |
		PFD_SUPPORT_OPENGL |
		PFD_DOUBLEBUFFER,
		PFD_TYPE_RGBA,
		32,
		0, 0, 0, 0, 0, 0,
		0,
		0,
		0,
		0, 0, 0, 0,
		0,
		0,
		0,
		PFD_MAIN_PLANE,
		0,
		0, 0, 0
	};
	

	hDC=GetDC(hWnd);
  PixelFormat=ChoosePixelFormat(hDC,&pfd);
	SetPixelFormat(hDC,PixelFormat,&pfd);
	hRC=wglCreateContext(hDC);
  wglMakeCurrent(hDC,hRC);

	ShowWindow(hWnd,SW_SHOW);
	SetForegroundWindow(hWnd);
	SetFocus(hWnd);

  glViewport(0,0,width,height);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-500,500,500,-500,-1.0f,1.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_CLOSE:
		{
			PostQuitMessage(0);
			return 0;
		}
	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int main(int argc, char *argv[])
{
  bool lRun=true;
  MSG lMsg;

  if (argc<2)
  {
    printf("You have to pass filename as argument!\n");
    return -1;
  }

  InitWindow(600,600);

  clsApplication lApp;
  lApp.openAndParseFile(argv[1]);
  lApp.produce();
  lApp.render(false);
  lApp.render(true,true);

  while (lRun)
  {
    if (PeekMessage(&lMsg,0,0,0,PM_REMOVE)!=0)
		{
			if (lMsg.message==WM_QUIT) {
        lRun=false;
      } else if (lMsg.message==WM_KEYUP) {
        if (lMsg.wParam==27) {
          lRun=false;
        } else if (lMsg.wParam=='P') {
          wchar_t lTitle[100];
          swprintf(lTitle,99,L"pL-Pictures, n=%u",lApp.changeN(1));
          SetWindowText(hWnd,lTitle);
          lApp.produce();
          lApp.render(false);
          lApp.render(true,true);
        } else if (lMsg.wParam=='L') {
          wchar_t lTitle[100];
          swprintf(lTitle,99,L"pL-Pictures, n=%u",lApp.changeN(-1));
          SetWindowText(hWnd,lTitle);
          lApp.produce();
          lApp.render(false);
          lApp.render(true,true);
        }

			} else {
				TranslateMessage(&lMsg);
				DispatchMessage(&lMsg);
			}
		} else {
       lApp.render();
       SwapBuffers(hDC);
    }
  }
  KillWindow();
  return 0;
}